import { UseStore } from 'zustand';
import { EqualityChecker } from 'zustand/vanilla';
declare module 'react-nil';
export declare type StateSelector<T, U> = (state: T) => U;
export declare type StateListener<T> = (state: T) => void;
export interface Subscribe<T> {
    (listener: StateListener<T>): () => void;
    <U>(listener: StateListener<T>, selector?: StateSelector<T, U>, equalityFn?: EqualityChecker<U>): () => void;
}
declare type StoreFamily<THookArgs extends any[]> = Map<any[], StoreInfo<THookArgs>>;
export interface UseValueStore<T> {
    (): T;
    <U>(selector: StateSelector<T, U>, equalityFn?: EqualityChecker<U>): U;
    family: StoreFamily;
}
declare type HookReturnsState<TState, THookArgs extends any[]> = (...any: THookArgs) => TState;
declare type StoreInfo<THookArgs extends any[]> = {
    useZStore: UseStore<any>;
    reactRoot: HTMLElement;
    render: (args: THookArgs) => void;
};
export default function create<TState, THookArgs extends any[]>(hook: HookReturnsState<TState, THookArgs>, ...defaultHookArgs: THookArgs): UseValueStore<TState>;
export declare const serializeHookArgs: (hookArgs: any[]) => string;
export declare function stableStringify(value: any): string;
export declare function isPlainObject(o: any): o is Object;
export {};
